﻿using System;
using System.Windows.Forms;

namespace Roulette
{
    public partial class FormMain : Form
    {
        private enum CancelReason
        {
            MaxCounts,
            NoMoney
        }

        public FormMain()
        {
            InitializeComponent();
        }

        private DataSetGame FillDataset(int maxRounds)
        {
            var dataSet = new DataSetGame();
            var rnd = new Random();
            CancelReason cancelReason = CancelReason.MaxCounts;

            long moneySet = 0;
            bool startNewRound = true;
            var money = (long) numericUpDownStartMoney.Value;
            var maxSet = (long) numericUpDownMaxSet.Value;
            var startSet = (long)numericUpDownStartValue.Value;
            int counter = 0;

            for (int i = 0; i <= maxRounds; i++)
            {
                counter = i;
                if (startNewRound)
                {
                    moneySet = startSet;
                    startNewRound = false;
                }
                else
                {
                    moneySet *= 2;
                    moneySet = Math.Min(maxSet, moneySet);
                }
                if (money < moneySet)
                {
                    cancelReason = CancelReason.NoMoney;
                    break;
                }
                money -= moneySet;

                bool winning = (rnd.NextDouble() < 0.5);

                if (winning)
                {
                    startNewRound = true;
                    dataSet.Game.AddGameRow(money + moneySet, moneySet, moneySet, money + 2*moneySet, true);
                    money += 2*moneySet;
                }
                else
                {
                    dataSet.Game.AddGameRow(money + moneySet, moneySet, 0, money, false);
                }
            }

            switch (cancelReason)
            {
                case CancelReason.MaxCounts:
                    labelCancelReason.Text = "Abbruch wegen: Rundenzahl erreicht!";
                    break;
                case CancelReason.NoMoney:
                    labelCancelReason.Text = "Abbruch wegen: Einsatz konnte nicht gebracht werden";
                    break;
                default:
                    throw new ArgumentOutOfRangeException();
            }
            labelResult.Text = string.Format("{0} Runden, Geld davor: {1}, Geld danach: {2}", counter, numericUpDownStartMoney.Value, money);

            return dataSet;
        }

        private void ButtonStartClick(object sender, EventArgs e)
        {
            dataGridViewGame.DataSource = FillDataset((int)numericUpDownCounter.Value).Game;
        }

    }
}
